/***************************************************************************
 *  Original Diku Mud copyright (C) 1990, 1991 by Sebastian Hammer,        *
 *  Michael Seifert, Hans Henrik St{rfeldt, Tom Madsen, and Katja Nyboe.   *
 *                                                                         *
 *  Merc Diku Mud improvments copyright (C) 1992, 1993 by Michael          *
 *  Chastain, Michael Quan, and Mitchell Tse.                              *
 *                                                                         *
 *  In order to use any part of this Merc Diku Mud, you must comply with   *
 *  both the original Diku license in 'license.doc' as well the Merc       *
 *  license in 'license.txt'.  In particular, you may not remove either of *
 *  these copyright notices.                                               *
 *                                                                         *
 *  Much time and thought has gone into this software and you are          *
 *  benefitting.  We hope that you share your changes too.  What goes      *
 *  around, comes around.                                                  *
 ***************************************************************************/

/***************************************************************************
*   ROM 2.4 is copyright 1993-1996 Russ Taylor                             *
*   ROM has been brought to you by the ROM consortium                      *
*       Russ Taylor (rtaylor@pacinfo.com)                                  *
*       Gabrielle Taylor (gtaylor@pacinfo.com)                             *
*       Brian Moore (rom@rom.efn.org)                                      *
*   By using this code, you have agreed to follow the terms of the         *
*   ROM license, in the file Rom24/doc/rom.license                         *
***************************************************************************/

/***************************************************************************
*   THE LABYRINTH is copyright 1996-2002 Sherene Neil and William          *
*       Wallace                                                            *
*   THE LABYRINTH is brought to you by THE LABYRINTH Team:                 *
*   Sherene Wallace (sherene-dw@comcast.net)                               *
*   William Wallace (williamwallace@comcast.net)                           *
*                                                                          *
*   By using this code, you have agreed to follow the terms of the         *
*   ROM license, in the file Rom24/doc/rom.license                         *
***************************************************************************/

#if defined(macintosh)
#include <types.h>
#elif defined(WIN32)
#include <time.h>
#else
#include <sys/types.h>
#include <sys/time.h>
#endif
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <time.h>
#include "merc.h"


void do_ride( CHAR_DATA *ch, char *argument )
{
    CHAR_DATA *victim;

    if ( argument[0] == '\0' )
    {
	send_to_char( "Mount whom?\n\r", ch );
	return;
    }

    if ( get_skill(ch, gsn_ride) == 0 )
    {
	send_to_char( "You don't know how to ride!\n\r", ch );
	return;
    }

    if ( (victim = get_char_room(ch, argument)) == NULL )
    {
	send_to_char( "They aren't here.\n\r", ch );
	return;
    }

    if ( ch->fighting != NULL )
    {
	send_to_char( "Not while you're in the middle of a fight!\n\r", ch );
	return;
    }

    if ( victim->fighting != NULL )
    {
	send_to_char( "They're moving around too much to mount!\n\r", ch );
	return;
    }
    
    if ( !IS_OUTSIDE(ch) )
    {
	send_to_char( "You can't do that indoors!\n\r", ch );
	return;
    }

    if ( ch->riding != NULL )
    {
	if ( ch->riding == victim )
	    send_to_char( "You are already riding them.\n\r", ch );
	else
	    send_to_char( "You are already riding someone else.\n\r", ch );
	
	return;
    }
    
    if ( ch->mounted_by != NULL )
    {
        send_to_char( "You're being ridden by someone else!\n\r", ch );
        return;
    }
    
    if ( victim->leader != ch && victim->master != ch )
    {
	send_to_char( "They aren't following you!\n\r", ch );
	return;
    }
    
    if ( !IS_NPC(victim) || !IS_SET(victim->act, ACT_MOUNT) )
    {
	send_to_char( "You can't ride them!\n\r", ch );
	return;
    }
    
    if ( victim->riding != NULL )
    {
        send_to_char( "They're riding someone else!\n\r", ch );
        return;
    }

    if ( victim->mounted_by != NULL )
    {
        send_to_char( "They're being ridden by someone else!\n\r", ch );
        return;
    }
    
    if ( CHAR_SIZE(ch) >= CHAR_SIZE(victim) )
    {
	send_to_char( "You need to find a bigger mount!\n\r", ch );
	return;
    }
    
    if ( IS_SET(CHAR_FORM(ch), FORM_CENTAUR)
    ||   IS_SET(CHAR_FORM(ch), FORM_INSECT)
    ||   IS_SET(CHAR_FORM(ch), FORM_SPIDER)
    ||   IS_SET(CHAR_FORM(ch), FORM_CRUSTACEAN)
    ||   IS_SET(CHAR_FORM(ch), FORM_WORM)
    ||   IS_SET(CHAR_FORM(ch), FORM_BLOB) )
    {
	send_to_char( "You can't quite work out how to ride them.\n\r", ch );
	return;
    }

    ch->riding		= victim;
    victim->mounted_by	= ch;

    act( "$n mounts $N, and starts riding $M.", ch, NULL, victim, TO_ROOM );
    act( "You mount $N, and start riding $M.",  ch, NULL, victim, TO_CHAR );
    act( "$n mounts you.",  ch, NULL, victim, TO_VICT );
}


void do_dismount( CHAR_DATA *ch, char *argument )
{
    if ( ch->riding == NULL )
    {
	send_to_char( "You're not riding anything.\n\r", ch );
	return;
    }

    act( "$n dismounts from $N.",  ch, NULL, ch->riding, TO_NOTVICT );
    act( "You dismount from $N.",  ch, NULL, ch->riding, TO_CHAR );
    act( "$n dismounts from you.", ch, NULL, ch->riding, TO_VICT );

    ch->riding->mounted_by	= NULL;
    ch->riding			= NULL;
}

